Subject: Re: [PATCH] revision: drop early output option

From: Junio C Hamano <[email-masked]>
Date: Mon, 21 Jul 2025 09:28:06 -0700

Jeff King <[email-masked]> writes:

> We added the --early-output feature long ago in cdcefbc971 (Add
> "--early-output" log flag for interactive GUI use, 2007-11-03). The idea
> was that GUIs could use it to progressively render a history view,
> showing something quick-and-inaccurate at first and then enhancing it
> later.
>
> But we never documented it, and it appears never to have been used, even
> by the projects which initially expressed interest. There was an RFC
> patch for gitk to use it:
>
>   http://public-inbox.org/git/[email-masked]/
>
> but it was never merged.

Ah, that one I remember.

> So let's drop the feature. It is extra code that is untested and
> undocumented, and makes working on the revision machinery more brittle.
>
> Given the history above, it seems unlikely that anybody is using it (or
> has used it), and we can drop it without the usual deprecation period.
>
> A gentler option might be to "soft" drop it: keep accepting the option,
> have it imply --topo-order as it does now, print "Final output: 1 done",
> and then do our regular traversal. That would keep any hypothetical
> caller working. But it doesn't seem worth the hassle to me.

True.

The safety of dropping of it (instead of fixing) relies on it not
being used at all, so using that same assumption that nobody even
attempts to use it by passing the option, would be a sensible thing
to do.

Will queue.  Thanks.